hdu 4709

求三角形的面积

利用向量点乘得到三角形的面积

三个for循环嵌套即可

#include<iostream>
#include<cstdio>
#include<cstring>
#include<vector>

using namespace std;

const double INF = 1e9+50;

double x[1000];
double y[1000];

double area(int i, int j, int k)
{
	double ax = x[i] - x[j];
	double ay = y[i] - y[j];
	double bx = x[k] - x[j];
	double by = y[k] - y[j];

	double ans = (ax*by - ay*bx)/2;
	if(ans < 0) return -ans;
	return ans;
}

int main()
{
	int T, N;
	double a, b, Min;
	scanf("%d", &T);
	while(T --)
	{
		Min = INF;
		scanf("%d", &N);
		for(int i = 0; i < N; i ++)
		{
			scanf("%lf%lf", &a, &b);
			x[i] = a;
			y[i] = b;
		}
		for(int i = 0; i < N; i ++)
			for(int j = i+1; j < N; j ++)
				for(int k = j+1; k < N; k ++)
				{
					double s = area(i, j, k);
					if(s < Min && s != 0.0) Min = s;
				}
		if(Min != INF){
			printf("%.2lf\n", Min);
		}
		else
		{
			printf("Impossible\n");
		}
	}

	return 0;
} 

hdu 4709

时间: 2024-10-01 00:28:59

hdu 4709的相关文章

HDU 4709 Herding 几何题解

求所有点组成的三角形最小的面积,0除外. 本题就枚举所有可以组成的三角形,然后保存最小的就是答案了,因为数据量很少. 复习一下如何求三角形面积.最简便的方法就是向量叉乘的知识了. 而且是二维向量叉乘P1(ax, ay), P2(bx, by),公式为:|P1 X P2| = abs(ax*by - ay*bx) 三角形面积就是|P1 X P2| / 2; 本题也是float过不了,换成double就可以过了. const int MAX_N = 101; struct VertexPoint {

HDU - 4709 Herding

Description Little John is herding his father's cattles. As a lazy boy, he cannot tolerate chasing the cattles all the time to avoid unnecessary omission. Luckily, he notice that there were N trees in the meadow numbered from 1 to N, and calculated t

hdu 4709 Herding (数学)

///给你n个点 枚举三点求最小三角形面积 # include <algorithm> # include <stdio.h> # include <string.h> # include <iostream> # include <math.h> # include <string> using namespace std; int main() { int t,n,i,j,k; double x[110],y[110],minn,

模拟2

    ID Origin Title 6 / 10 Problem A HDU 4706 Children's Day 7 / 22 Problem B HDU 4707 Pet 5 / 25 Problem C HDU 4708 Rotation Lock Puzzle 6 / 26 Problem D HDU 4709 Herding 1 / 9 Problem E HDU 4710 Balls Rearrangement     Problem F HDU 4711 Weather  

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是